
Ruby - Bug #7615

assignment to context variable changes the precedence order of function call with followed by ' ('

(whitespace-bracket)

12/24/2012 03:18 PM - snoble (Steven Noble)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version:    

ruby -v: ruby 2.0.0dev (2012-12-01 trunk 38126)

[x86_64-darwin12.2.0]

Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:

UNKNOWN

Description

this is similar to http://bugs.ruby-lang.org/issues/1801 but it wasn't pointed out then that ruby will use two different parsings at

different times

note that in this code a and b have the same assignment code but are assigned different values

code:

def foo(x); 99; end

a = foo (44) / 11

foo = 99999999

b = foo (44) / 11

puts "a: #{a} b: #{b}" #output of "a: 99 b: 9"

The output of ruby_parser is:

s(:block,

s(:defn, :foo, s(:args, :x), s(:lit, 99))

s(:lasgn, :a, s(:call, nil, :foo, s(:call, s(:lit, 44), :/, s(:lit, 11)))),

s(:lasgn, :foo, s(:lit, 999999999)),

s(:lasgn, :b, s(:call, s(:call, nil, :foo, s(:lit, 44)), :/, s(:lit, 11)))

)

observed in 1.9.4 and 2.0.0-preview2, but does not occur in 1.8.7

History

#1 - 01/22/2013 04:46 AM - snoble (Steven Noble)

is this result not extremely surprising to anyone else? I would expect a and b to be assigned the same value

#2 - 01/25/2013 12:53 PM - ko1 (Koichi Sasada)

- Category set to core

- Assignee set to nobu (Nobuyoshi Nakada)

- Target version set to 2.0.0

Nobu, could you check it?

#3 - 02/19/2013 01:49 AM - mame (Yusuke Endoh)

- Subject changed from assignment to context variable changes the precedence order of function call with followed by ' (' (whitespace-bracket) to

assignment to context variable changes the precedence order of function call with followed by &#x27; (&#x27; (whitespace-bracket)

- Status changed from Open to Assigned

- Target version changed from 2.0.0 to 2.6

Interesting, but I'm reluctant to fix this in 2.0.0 because it looks impractical and incompatible to 1.9.X.

--

Yusuke Endoh mame@tsg.ne.jp

#4 - 12/25/2017 06:15 PM - naruse (Yui NARUSE)

- Target version deleted (2.6)
#5 - 08/07/2019 04:36 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Assigned to Closed

This was fixed between Ruby 2.4 and 2.5:

$ ruby24 -e '

> def foo(x); 99; end

> a = foo (44) / 11

> foo = 99999999

> b = foo (44) / 11

> puts "a: #{a} b: #{b}"'

a: 99 b: 9

$ ruby25 -e '

> def foo(x); 99; end

> a = foo (44) / 11

> foo = 99999999

> b = foo (44) / 11

> puts "a: #{a} b: #{b}"'

a: 99 b: 99
